if(!apg) {
    var apg = {};
}

apg.settings = {};
apg.enabled = true;
apg.mySettings = {};

apg.url = function (url) {
    var message = {
        newTab: true,
        data: {url: url}
    };
    chrome.extension.sendMessage(message);
};

apg.settings.save  = function () {
    $(".learnSetting").each(function(){
        apg.mySettings[$(this).attr("name")] = $(this).val();
    });
    
    apg.mySettings.enabled = apg.enabled;
    
    var message = {
        saveSettings: true,
        data: apg.mySettings
    };
    chrome.extension.sendMessage(message);
};

apg.settings.load  = function () {
    chrome.extension.sendMessage({getSettings: true}, function(response) {
        
        apg.mySettings = response;
        
        $.each(apg.mySettings.customLangs, function(code, lang){
            var option = $("<option></option>").html(lang).attr("value", code);
            $("#addMore").before(option);
        });
        
        $(".learnSetting").each(function(){
            $(this).val(response[$(this).attr("name")]);
        });
        
        if(response["enabled"] === "true" || response["enabled"] === true) {
            apg.enabled = true;
            apg.mySettings.enabled = true;
        }
        else if(response["enabled"] === "false" || response["enabled"] === false) {
            apg.enabled = false;
            apg.mySettings.enabled = false;
        }
        
        apg.settings.updateEnable();
    });
};

apg.settings.bind  = function () {
    
    $(".learnSetting").change(function(e){
        var that = $(this);
        
        if(that.attr("id") == "translateTo" && that.val() == "more") {
            apg.settings.load();
            apg.url("settings.html");
            return;
        }
        
        apg.settings.save();
    });
    
    $("#learnerStatus").click(function(){
        apg.settings.enableClicked();
    });
    
    $("#faqLink").click(function () {
        apg.url("about.html");
    });
    $("#setLink").click(function () {
        apg.url("settings.html");
    });
    $("#dicLink").click(function () {
        apg.url("dictionary.html");
    });
    $(".mymemoryLink").click(function () {
        apg.url("http://mymemory.translated.net/");
    });
};

apg.settings.enableClicked = function(){
    if(apg.enabled) {
        apg.enabled = false;
    }
    else {
        apg.enabled = true;
    }
    
    apg.settings.updateEnable();
    apg.settings.save();
}

apg.settings.updateEnable = function () {
    if(apg.enabled === true) {
        $("#learnerStatus").css({'background-color': '#0F0'});
        $("#learnerStatus").text('ON');
        chrome.browserAction.setIcon({path: 'logo_48.png'});
    }
    else {
        $("#learnerStatus").css({'background-color': '#F00'});
        $("#learnerStatus").text('OFF');
        chrome.browserAction.setIcon({path: 'logo_disabled_48.png'});
    }
}

$(function(){
    apg.settings.load();
    apg.settings.bind();
});

