apg = {};

apg.mySettings = new Array();

apg.renderOptions = {
    perPage     : 35,
    currentPage : 1
}

apg.currentDictionary = {};
/*
 * Langauge Settings
 */
apg.getAllLanguages = function () {
    return {"ab" : "Abkhazian", "af" : "Afrikaans", "an" : "Aragonese", "ar" : "Arabic", "as" : "Assamese", "az" : "Azerbaijani", "be" : "Belarusian", "bg" : "Bulgarian", "bn" : "Bengali", "bo" : "Tibetan", "br" : "Breton", "bs" : "Bosnian", "ca" : "Catalan / Valencian", "ce" : "Chechen", "co" : "Corsican", "cs" : "Czech", "cu" : "Church Slavic", "cy" : "Welsh", "da" : "Danish", "de" : "German", "el" : "Greek", "en" : "English", "eo" : "Esperanto", "es" : "Spanish / Castilian", "et" : "Estonian", "eu" : "Basque", "fa" : "Persian", "fi" : "Finnish", "fj" : "Fijian", "fo" : "Faroese", "fr" : "French", "fy" : "Western Frisian", "ga" : "Irish", "gd" : "Gaelic / Scottish Gaelic", "gl" : "Galician", "gv" : "Manx", "he" : "Hebrew", "hi" : "Hindi", "hr" : "Croatian", "ht" : "Haitian; Haitian Creole", "hu" : "Hungarian", "hy" : "Armenian", "id" : "Indonesian", "is" : "Icelandic", "it" : "Italian", "ja" : "Japanese", "jv" : "Javanese", "ka" : "Georgian", "kg" : "Kongo", "ko" : "Korean", "ku" : "Kurdish", "kw" : "Cornish", "ky" : "Kirghiz", "la" : "Latin", "lb" : "Luxembourgish; Letzeburgesch", "li" : "Limburgan; Limburger; Limburgish", "ln" : "Lingala", "lt" : "Lithuanian", "lv" : "Latvian", "mg" : "Malagasy", "mk" : "Macedonian", "mn" : "Mongolian", "mo" : "Moldavian", "ms" : "Malay", "mt" : "Maltese", "my" : "Burmese", "nb" : "Norwegian (Bokmål)", "ne" : "Nepali", "nl" : "Dutch", "nn" : "Norwegian (Nynorsk)", "no" : "Norwegian", "oc" : "Occitan (post 1500); Provençal", "pl" : "Polish", "pt" : "Portuguese", "rm" : "Raeto-Romance", "ro" : "Romanian", "ru" : "Russian", "sc" : "Sardinian", "se" : "Northern Sami", "sk" : "Slovak", "sl" : "Slovenian", "so" : "Somali", "sq" : "Albanian", "sr" : "Serbian", "sv" : "Swedish", "sw" : "Swahili", "tk" : "Turkmen", "tr" : "Turkish", "ty" : "Tahitian", "uk" : "Ukrainian", "ur" : "Urdu", "uz" : "Uzbek", "vi" : "Vietnamese", "vo" : "Volapük", "yi" : "Yiddish", "zh" : "Chinese"};
}

apg.getUsedLanguages = function () {
    var used = new Array(
        "zh-CN",
        "ca",
        "hr",
        "nl",
        "eo",
        "fr",
        "de",
        "el",
        "it",
        "ja",
        "ko",
        "la",
        "no",
        "es",
        "sv",
        "sw",
        "tr"
    );

    $.each(apg.mySettings.customLangs, function (code, lang) {
        used.push(code)
    });

    return used;
};

apg.searchLanguages = function () {
    $("#langResults").hide();
    $("#langResults").html("");

    var langs, used, html = "";
    var val = $("#languageChooser").val().toLowerCase();

    if (val.length > 1) {
        langs = apg.getAllLanguages();
        used = apg.getUsedLanguages();
        //console.log(used);
        $.each(langs, function (code, lang) {

            if ($.inArray(code, used) !== -1) {
                //console.log(code);
                return;
            }

            if (code.toLowerCase().indexOf(val) > -1 || lang.toLowerCase().indexOf(val) > -1) {
                html = $('<div></div>').html(lang + ' (' + code + ')').click(function () {
                    apg.languageClicked(lang, code);
                });
                $("#langResults").append(html);
            }
        });
    }


    if (html != "") {
        $("#langResults").show();
    }
}

apg.languageClicked = function (lang, code) {
    if (!apg.mySettings.customLangs) {
        apg.mySettings.customLangs = {};
    }
    apg.mySettings.customLangs[code] = lang;
    apg.saveSettings();
    apg.writeCusomLangs();
    $("#languageChooser").val("");
    $("#languageChooser").trigger("keyup");
};

apg.removeLang = function (code) {
    delete apg.mySettings.customLangs[code];
    apg.writeCusomLangs();
    apg.saveSettings();
};

apg.writeCusomLangs = function () {
    var div, count = 0;
    $("#customLangs").html('');

    if (!apg.mySettings.customLangs) {
        apg.mySettings.customLangs = {};
    }

    $.each(apg.mySettings.customLangs, function (code, lang) {
        count++;
        var div = $('<div></div>').html(lang + ' (' + code + ')').attr('title', "Click to remove").click(function () {
            apg.removeLang(code);
        });
        $("#customLangs").append(div);
    });

    if (count == 0) {
        $("#customLangs").html("<i>No Languages Added</i>");
    }
}

/*
 * Enabled Sites Settings
 */

apg.selectBlackList = function () {
    $("#blackSelector").addClass("selected");
    $("#whiteSelector").removeClass("selected");
    $("#siteWhiteList").hide();
    $("#siteBlackList").show();
    apg.mySettings.filterType = "black";
};

apg.selectWhiteList = function () {
    $("#whiteSelector").addClass("selected");
    $("#blackSelector").removeClass("selected");
    $("#siteBlackList").hide();
    $("#siteWhiteList").show();
    apg.mySettings.filterType = "white";
};

apg.updateHighlightUi = function () {

    $('#highlightOff').removeClass('chosen');
    $('#highlightOn').removeClass('chosen');

    if (apg.mySettings.highlighting === 'off') {
        $('#highlightOff').addClass('chosen');
    }
    else {
        $('#highlightOn').addClass('chosen');
    }
};

apg.setHighlight = function (setTo) {
    if (setTo === 'off') {
        apg.mySettings.highlighting = 'off';
    }
    else {
        apg.mySettings.highlighting = 'on';
    }

    apg.saveSettings();
    apg.updateHighlightUi();
};

/*
 * Settings Meta
 */
apg.textareaToArray = function (id) {
    var val = $("#" + id).val();
    val = val.split("\n");

    var ret = new Array();
    $.each(val, function (index, value) {
        value = $.trim(value.toLowerCase());
        value = value.replace("\n", "");
        if (value != "") {
            ret.push(value);
        }
    });

    return ret;
}

apg.arrayToTextArea = function (array, id) {
    var list = "";
    $.each(array, function (index, word) {
        list += word + "\n"
    });

    $("#" + id).val(list);
}

apg.applySettings = function () {
    //console.log(apg.mySettings);
    apg.writeCusomLangs();

    $("#minLength").val(apg.mySettings.minLength);

    if (apg.mySettings.filterType == "black") {
        apg.selectBlackList();
    }
    else {
        apg.selectWhiteList();
    }

    apg.updateHighlightUi();

    apg.arrayToTextArea(apg.mySettings.wordBlackList, "wordBlackList");
    apg.arrayToTextArea(apg.mySettings.siteBlackList, "siteBlackList");
    apg.arrayToTextArea(apg.mySettings.siteWhiteList, "siteWhiteList");
}

apg.saveSettings = function () {
    var message = {
        saveSettings : true,
        data         : apg.mySettings
    };

    chrome.extension.sendMessage(message);
};

apg.url = function (url) {
    var message = {
        newTab : true,
        data   : {url : url}
    };
    chrome.extension.sendMessage(message);
};

apg.bind = function () {
    $("#languageChooser").keyup(function () {
        apg.searchLanguages();
    });

    $("#minLength").change(function () {
        apg.mySettings.minLength = $("#minLength").val();
        apg.saveSettings();
    });

    $("#wordBlackList").change(function () {
        apg.mySettings.wordBlackList = apg.textareaToArray("wordBlackList");
        apg.saveSettings();
    });

    $("#siteBlackList").change(function () {
        apg.mySettings.siteBlackList = apg.textareaToArray("siteBlackList");
        apg.saveSettings();
    });

    $("#siteWhiteList").change(function () {
        apg.mySettings.siteWhiteList = apg.textareaToArray("siteWhiteList");
        apg.saveSettings();
    });

    $('#highlightOn').click(function () {
        apg.setHighlight('on');
    });

    $('#highlightOff').click(function () {
        apg.setHighlight('off');
    });

    $(".listSelector").click(function () {
        var that = $(this);

        if (that.hasClass("selected")) {
            return;
        }

        if (that.attr("id") == "whiteSelector") {
            apg.selectWhiteList();
        }
        else {
            apg.selectBlackList();
        }
        apg.saveSettings();
    });
};

apg.editDictionaryPrompt = function (word, current) {
    var html = '';
    html += '' +
        '<div id="background">' +
        '<div id="modal">' +
        '<h4>Edit Entry: ' + word + '</h4>' +
        '<input type="text" value="' + current + '" id="newValue">' +
        '<br />' +

        '<a href="#" class="menuLink" id="cancelEntry">Cancel</a>' +
        '<a href="#" class="menuLink" id="saveEntry">Save</a>' +
        '<br style="clear:both;" />' +
        '</div>' +
        '</div>';

    $(document.body).append(html);

    $('#background').height($(document).height());

    $('#cancelEntry').click(function (e) {
        e.preventDefault();
        $('#background').remove();
    });

    $('#saveEntry').click(function (e) {
        e.preventDefault();
        apg.currentDictionary[word] = $('#newValue').val().toLocaleLowerCase();
        apg.persistCurrentDictionary();
        $('#background').remove();
    });


};

apg.persistCurrentDictionary = function () {
    chrome.extension.sendMessage({
        saveDictionary  : true,
        dictionary      : apg.currentDictionary,
        currentLanguage : $('#chooseDictionary').val()
    });
    apg.renderDictionary();
}

apg.bindDictionaryEdit = function () {

    $('.editLink').click(function () {
        var row = $(this).parent().parent(),
            word = $('.original', row).html(),
            current = $('.translation', row).html();
        apg.editDictionaryPrompt(word, current);
    });

    $('.addLink').click(function () {
        var row = $(this).parent().parent(),
            word = $('.newTerm', row).html();
        apg.editDictionaryPrompt(word, '');
    });

    $('.deleteLink').click(function () {
        var row = $(this).parent().parent(),
            word = $('.original', row).html();
        delete apg.currentDictionary[word];

        chrome.extension.sendMessage({
            blackListWord : true,
            word          : word
        });

        apg.persistCurrentDictionary();
    });
}

apg.alphabetizeDictionary = function () {
    var keys = Object.keys(apg.currentDictionary),
        i,
        newDictionary = {},
        len = keys.length;

    keys.sort();

    for (i = 0; i < len; i++) {
        newDictionary[keys[i]] = apg.currentDictionary[keys[i]];
    }

    apg.currentDictionary = newDictionary;
    apg.persistCurrentDictionary();
    apg.renderDictionary();
}

apg.matches = function (term, word, translation) {
    if (term === '') {
        return true;
    }

    if (word.indexOf(term) === 0) {
        return true;
    }
    if (translation.indexOf(term) === 0) {
        return true;
    }
    return false;
}

apg.renderDictionary = function () {
    var count = 0,
        matchCount = 0,
        displayedCount = 0,
        i, html = '',
        dictionary = apg.currentDictionary,
        searchTerm = $('#searchInput').val().toLocaleLowerCase(),
        perPage = apg.renderOptions.perPage,
        startIndex = (apg.renderOptions.currentPage * perPage) - perPage,
        endIndex = startIndex + perPage,
        googleLink = 'http://translate.google.com/#en/' + apg.mySettings.translateTo + '/';

    $('#clearSearch').hide();
    if (searchTerm != '') {
        $('#clearSearch').show();
    }

    for (i in dictionary) {

        if (apg.matches(searchTerm, i, dictionary[i])) {

            if (matchCount < endIndex && matchCount >= startIndex) {
                html += '<div class="entryLine"><span class="entry original">' + i + '</span>'
                    + '<span  class="entry translation">' + dictionary[i] + '</span>'
                    + '<span  class="entry google"> <a target="_blank" href="' + googleLink + i + '">Translations</a>  </span>'
                    + '<span  class="entry edit">   <a class="editLink" href="javascript:void(0);">Edit</a>     </span>'
                    + '<span  class="entry delete"> <a class="deleteLink" href="javascript:void(0);">Delete</a> </span>'
                    + '</div>';
                displayedCount++;
            }
            matchCount++;
        }
        count++;
    }

    if (count === 0) {
        html = '<div class="entryLine"><span class="entry full">This dictionary is empty.</span></div>'
    }
    else {
        if (matchCount === 0) {
            html += '<div class="entryLine"><span class="entry full"><a class="addLink" href="#">Add `<span class="newTerm">' + searchTerm + '</span>` to Dictionary</a></span></div>'

        }
        html += '<div class="entryLine"><span class="entry full">Displaying ' + displayedCount + ' of ' + matchCount + ' matches.</span></div>'

    }

    $('#dictionary').html(html);

    $('#entryCount').html('(' + count + ' Entries)');

    apg.renderPageInfo(matchCount);

    apg.bindDictionaryEdit();
};

apg.renderPageInfo = function (count) {
    var totalPages = Math.ceil(count / apg.renderOptions.perPage),
        currentPage = apg.renderOptions.currentPage,
        pageText = 'Page ' + currentPage + ' of ' + totalPages,
        html = '';

    for (var p = 1; p <= totalPages; p++) {
        if (p < 5 || p > (totalPages - 3) || Math.abs(p - currentPage) < 2) {

            if (p === totalPages - 2 && currentPage < (totalPages - 4) && totalPages > 7) {
                html += ' [...] '
            }

            if (p === currentPage) {
                html += ' <span class="currentPage">' + p + '</span> ';
            }
            else {
                html += ' <a href="javascript:void(0);" class="pageNumber">' + p + '</a> ';
            }

            if (p === 4 && currentPage >= 7 && totalPages > 7) {
                html += ' [...] '
            }

        }
    }
    pageText = '';
    $('#pageInfo').html(html + pageText);

    $('.pageNumber').click(function () {
        apg.renderOptions.currentPage = parseInt($(this).html(), 10);
        apg.renderDictionary()
    });

    $('#nextPage').css('visibility', 'visible');
    $('#lastPage').css('visibility', 'visible');
    if (currentPage == totalPages) {
        $('#nextPage').css('visibility', 'hidden');
    }
    if (currentPage == 1) {
        $('#lastPage').css('visibility', 'hidden');
    }
}

apg.checkHash = function () {
    if (window.location.hash != '' && window.location.hash != '#flewentDictionarySettings') {
        var res = $('.editLink');
        if (res.length === 1) {
            res.trigger('click');
            window.location.hash = '';
        }
    }
};

apg.bindDictionary = function () {
    var term = window.location.hash;

    if (term != '' && term != '#flewentDictionarySettings') {
        term = term.substr(1);
        $('#searchInput').val(term);
    }

    $('#searchButton').click(function () {
        apg.renderOptions.currentPage = 1;
        apg.renderDictionary();
    });

    $('#searchInput').keyup(function (e) {
        if (e.keyCode == 13) {
            apg.renderOptions.currentPage = 1;
            apg.renderDictionary();
        }
    });


    $('#clearSearch').click(function () {
        $('#searchInput').val('');
        apg.renderDictionary();
    });

    $('#alphabetize').click(function () {
        apg.alphabetizeDictionary();
    });

    $('#lastPage').click(function () {
        apg.renderOptions.currentPage--;
        apg.renderDictionary();
    });

    $('#nextPage').click(function () {
        apg.renderOptions.currentPage++;
        apg.renderDictionary();
    });


    $("#chooseDictionary").change(function () {
        $("#selectedLanguage").html($('option:selected', this).html());
        chrome.extension.sendMessage({
                getDictionary   : true,
                currentLanguage : $(this).val()
            },
            function (dictionary) {
                apg.currentDictionary = dictionary;
                apg.renderDictionary();
                apg.checkHash();
            });
    });

    $('#maxDictionary').change(function () {
        apg.mySettings.maxDictionary = $('#maxDictionary').val();
        apg.saveSettings();
    });

    $('#growthRate').change(function () {
        apg.mySettings.growthRate = $('#growthRate').val();
        apg.saveSettings();
    });

};

apg.applyDictionarySettings = function () {
    $.each(apg.mySettings.customLangs, function (code, lang) {
        var option = $("<option></option>").html(lang).attr("value", code);
        $("#chooseDictionary").append(option);
    });

    $("#chooseDictionary").val(apg.mySettings.translateTo).trigger('change');

    $('#maxDictionary').val(apg.mySettings.maxDictionary);
    $('#growthRate').val(apg.mySettings.growthRate);
}

apg.start = function () {
    //get settings
    chrome.extension.sendMessage({getSettings : true}, function (response) {
        apg.mySettings = response;
        apg.applySettings();
    });

    //do binding
    apg.bind();
};

apg.dictionaryStart = function () {
    //get settings
    chrome.extension.sendMessage({getSettings : true}, function (response) {
        apg.mySettings = response;
        apg.applyDictionarySettings();
    });

    //do binding
    apg.bindDictionary();
};

